#ifndef __MATRIX_INC_H__
#define __MATRIX_INC_H__

class_<Matrix>("Matrix")
    /// we have to define an init method for
    /// each possible version available above
    .def(init<>())
    .def(init<ngl::Real>())
    .def(init<int>())
    .def(init<double>())
    // prototype the methods

    .def("openGL",&Matrix::getOpenGL)
    .def("identity",&Matrix::identity,return_value_policy<reference_existing_object>())
    .def("transpose",&Matrix::transpose,return_value_policy<reference_existing_object>())
    .def("rotateX",&Matrix::rotateX)
    .def("rotateY",&Matrix::rotateY)
    .def("rotateZ",&Matrix::rotateZ)
    .def("translate",&Matrix::translate)
    .def("scale",&Matrix::scale)
    .def("null",&Matrix::null,return_value_policy<reference_existing_object>())
    .def("determinant",&Matrix::determinant)
    .def("euler",&Matrix::euler)
    .def("inversePossible",&Matrix::inversePossible)
    .def("getInverse",&Matrix::getInverse)
    .def("loadModelView",&Matrix::loadModelView)
    .def("loadProjection",&Matrix::loadProjection)
    .def("fromModelView",&Matrix::fromModelView)
    .def("fromProjection",&Matrix::fromProjection)

    /// operator overloads
    .def(self *  ngl::Matrix())
    .def(self *= ngl::Matrix())
    .def(self +  ngl::Matrix())
    .def(self +=  ngl::Matrix())
    .def(self * ngl::Real())
    .def(self *= ngl::Real())
    .def(self * ngl::Vector())
  //  .def(ngl::Vector() * self)

    /// this is the same as the [] operators
    .def("__getitem__",&Matrix::getItem)
    .def("__setitem__",&Matrix::setItem)
    .def("__str__",&Matrix::pyPrint)


    ;

#endif


/*
  void SubMatrix3x3(
                    const int _i,
                    const int _j,
                    Real o_mat[]
                   ) const;


  Quaternion AsQuaternion() const;
  Vector operator * (
                     const Vector &_v
                    ) const;

 */


