#ifndef __VBOPRIMITIVES_INC_H__
#define __VBOPRIMITIVES_INC_H__
// import the namespace for convenience
using namespace boost::python;

enum_<VBOPrimitives::DrawModes>("DrawModes")
      .value("SOLID", VBOPrimitives::SOLID)
      .value("WIREFRAME", VBOPrimitives::WIREFRAME)
      ;

/// notice no_init and nocopyable as singleton,

class_<VBOPrimitives,boost::noncopyable>("VBOPrimitives",no_init)
    /// we have to define an init method for
    /// each possible version available above

    .def("instance", &VBOPrimitives::instance,
      return_value_policy<reference_existing_object>()).staticmethod("instance")

    .def("createVBOSphere",&VBOPrimitives::createVBOSphere)
    .def("createVBOTrianglePlane",&VBOPrimitives::createVBOTrianglePlane)
    .def("createVBOQuadPlane",&VBOPrimitives::createVBOQuadPlane)
    .def("createVBOCone",&VBOPrimitives::createVBOCone)
    .def("createVBOCylinder",&VBOPrimitives::createVBOCylinder)
    .def("createVBODisk",&VBOPrimitives::createVBODisk)
    .def("createVBOTorus",&VBOPrimitives::createVBOTorus)

    .def("loadBinaryVBO",&VBOPrimitives::loadBinaryVBO)
    .def("createVBOFromHeader",&VBOPrimitives::createVBOFromHeader)
    .def("getTotalBufferSize",&VBOPrimitives::getTotalBufferSize)
    .def("clearVBOs",&VBOPrimitives::clearVBOs)
    .def("drawNormals",&VBOPrimitives::drawNormals)
    .def("drawVerts",&VBOPrimitives::drawVerts)
    .def("drawFaceNormals",&VBOPrimitives::drawFaceNormals)
    .def("draw",&VBOPrimitives::draw)

 ;

/// \todo implement the following
///  .def("RemoveVBO",&VBOPrimitives::RemoveVBO)
// .def("MapVBO",&VBOPrimitives::MapVBO)
// .def("UnMapVBO",&VBOPrimitives::UnMapVBO)



#endif


