namespace ngl
{

void (Vector::*vectorSetF)(const ngl::Real &,const ngl::Real &,const ngl::Real &,const  ngl::Real &) = &Vector::set;
void (Vector::*vectorSetC)(const ngl::Vector &) = &Vector::set;

void (Vector::*cross2)(const ngl::Vector &, const ngl::Vector &) = &Vector::cross;
ngl::Vector (Vector::*cross)(const ngl::Vector &)const =&Vector::cross;


bool Vector::equals( const ngl::Vector& _x, const ngl::Vector& _y ) const {return _x==_y;}


ngl::Real Vector::getItem(int _index)
{
  if(_index<0 && _index >3)
  {
    PyErr_SetString(PyExc_IndexError, "Index out of range.");
    boost::python::throw_error_already_set();
  }
  return m_openGL[_index];
}

void Vector::setItem(int _index, ngl::Real _value)
{
  if(_index<0 && _index >3)
  {
    PyErr_SetString(PyExc_IndexError, "Index out of range.");
    boost::python::throw_error_already_set();
  }

    m_openGL[_index]=_value;
}

std::string Vector::pyPrint()
{
  boost::format fmtr("[%f,%f,%f,%f]");
  fmtr % m_x % m_y % m_z % m_w;
  return fmtr.str();
}

boost::python::tuple Vector::getOpenGL()
{
    return boost::python::make_tuple(m_x,m_y,m_z,m_w);
}

}; // end namespace
