#ifndef __VECTOR_INC_H__
#define __VECTOR_INC_H__

class_<Vector>("Vector")
    /// we have to define an init method for
    /// each possible version available above
    .def(init<ngl::Real,ngl::Real,ngl::Real,ngl::Real >())
    .def(init<ngl::Real, ngl::Real,ngl::Real>())
    //.def(init<ngl::Real, ngl::Real>())
//    .def(init<int &>())
  //  .def(init<double &>())

    //.def(init<>())
    // prototype the methods
    .def("openGL",&Vector::getOpenGL)
    .def("normal",&Vector::normal)
    .def("vertex",&Vector::vertex)
    .def("translate",&Vector::translate)
    .def("dot",&Vector::dot)
    .def("set", vectorSetF)
    .def("set", vectorSetC)
    .def("null",&Vector::null)
    .def("length",&Vector::length)
    .def("reverse",&Vector::reverse)
    .def("normalize",&Vector::normalize)
    .def("cross",cross2)
    .def("cross",cross)
    /// operator overloads
    .def(self + Vector())
    .def(self - Vector())
    .def(self += Vector())
    .def(self -= Vector())
    .def(self * Vector())
    .def(Vector()*self)
    .def(self * ngl::Real())
    .def(self / ngl::Real())
    .def(self /= ngl::Real())
    .def(self * ngl::Matrix())

    .def("__eq__",&Vector::equals)
    /// this is the same as the [] operators
    .def("__getitem__",&Vector::getItem)
    .def("__setitem__",&Vector::setItem)
    .def( self != Vector())
    .def( self / Vector())
    .def("angleBetween",&Vector::angleBetween)
    .def("inner",&Vector::inner)
    .def("outer",&Vector::outer)
    .def("lengthSquared",&Vector::lengthSquared)
    .def("__str__",&Vector::pyPrint)


;



#endif
